
#include <cybiko.h>
#include "cvc.h"
#include "storm.h"

struct
{
long frame;
short length;
}subhdr;

/******** DECODER FUNCTIONS *******/

void dec_enc_cv1(char *,char *,int);
void dec1_cv1(char *,char *,int);
void dec2_cv1(char *,char *,int);

int getinput(struct module_t *);
void snapshot(char *);
//
void gencode(char *);
void extract(char *,char *,long *,char *,short,long);

/******** CYBIKO CVC STRUCTS *******/

struct cvc_header cy_main_hdr;
struct cvc_video cy_vid_hdr;
struct cvc_audio cy_aud_hdr;
struct cvc_frame cy_vid_frame;

struct FileInput file_input;
struct FileInput sub_input;

// Subtitle displayer function (getting better..)

void displaysub(char *buf,struct module_t *ptr_main_module)
{
int c=0,fsize,wpos,i=0,sw,j=70,exit=0;
char in,myword[40];

fsize=strlen(buf);

do
{

// Get a word
memset(myword,0,sizeof(myword));
wpos=0;

do{
in=buf[c++];
	if(in>32)
	{
	myword[wpos++]=in;
	}
}while(in!=32 && c<fsize);
myword[wpos]=0;
if (c>=fsize){exit=1;}

//

sw=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx), myword );
if ((i+sw)>160){i=0;j+=10;}

TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
DisplayGraphics_draw_text(ptr_main_module->m_gfx,myword, i,j );

TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
DisplayGraphics_draw_text(ptr_main_module->m_gfx,myword, i+1, j+1 );

i=i+sw+8;
}while(exit==0);

}



void cvc(char *myfile,struct module_t *ptr_main_module)
{
long c;
int ffwd=0,paused=0,cnt,subs=0,i,tablesize;
char *frm,*cyf,no,*text,*subfile,*scr,*code,*table;

scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

// Huffman memory
code=(char *)calloc(1024,sizeof(char));
table=(char *)calloc(256,sizeof(char));

//Subtitling
subfile=(char *)calloc(256,sizeof(char));
text=(char *)calloc(256,sizeof(char));

// Frame memory
frm=(char *)calloc(4010,sizeof(char));
cyf=(char *)calloc(4010,sizeof(char));

#if DEBUG==1  
	if(table==0){TRACE("Memory Error - Table");};
	if(code==0){TRACE("Memory Error - Code");};
	if(subfile==0){TRACE("Memory Error - Subfile");};
	if(text==0){TRACE("Memory Error - Text");};
	if(frm==0){TRACE("Memory Error - Frm");};
	if(cyf==0){TRACE("Memory Error - Cyf");};
#endif

/*
memset(code,0,1024);
memset(table,0,256);
memset(subfile,0,256);
memset(text,0,256);
memset(frm,0,4000);
memset(cyf,0,4000);
*/

#if DEBUG==1  
	TRACE("Loading Codes");
#endif

gencode(code);

#if DEBUG==1  
	TRACE("Done..");
#endif
//


//First two bytes of a frame will be the tablesize (if present)

FileInput_ctor(&file_input);
FileInput_ctor(&sub_input);

strcpy(subfile,myfile);
memcpy(subfile+strlen(subfile)-3,"sub",3);


if( FileInput_open( &sub_input,subfile ))
{
	#if DEBUG==1 
		TRACE("Subtitle file -%s- found",subfile);
	#endif

	// Load first subtitle header
	Input_read(&sub_input,&subhdr,6);
	subs=1;
}
else
{
	#if DEBUG==1 
		TRACE("No subtitle file -%s- found",subfile);
	#endif

	subs=-1;
}

if( FileInput_open( &file_input, myfile ))
{
#if DEBUG==1 
	TRACE("Load Main Header...");
#endif

Input_read( &file_input, &cy_main_hdr,12);

#if DEBUG==1 
	TRACE("Load Video Header...");
#endif

Input_read( &file_input, &cy_vid_hdr,18);

#if DEBUG==1 
	TRACE("File : %s",myfile);
	TRACE("Size : %d x %d",cy_vid_hdr.x,cy_vid_hdr.y);
	TRACE("Rate : %d x %d",cy_vid_hdr.frames,cy_vid_hdr.fps);
#endif

for(c=0;c<cy_vid_hdr.frames;c++)
{
Input_read( &file_input, &cy_vid_frame,6);

if ((cy_vid_frame.subtype==0 || cy_vid_frame.subtype==1) && ffwd==1)
{
ffwd=0;
}

do{
     
	switch(getinput(ptr_main_module))
        {
 		case KEY_ESC:
			c=cy_vid_hdr.frames;
		break;

		case KEY_SPACE:
			paused=1-paused;
			ffwd=0;
	
			#if DEBUG==1 
				TRACE("paused");
			#endif
		break;

		case KEY_LEFT:
			ffwd=0;
			#if DEBUG==1 
				TRACE("rewd");
			#endif
		break;

		case KEY_RIGHT:
			ffwd=1;
			#if DEBUG==1 
				TRACE("ffwd");			
			#endif
		break;

		case KEY_T:
			if (subs!=-1)
			{
			#if DEBUG==1 
				TRACE("Subs switched on/off");
			#endif
			subs=1-subs;
			}
			else
			{
			#if DEBUG==1 
				TRACE("No subs to switch on/off");
			#endif
			}	
		break;
		
		case KEY_S:
		{
		#if DEBUG==1 
			TRACE("Snapshot Taken, saved as snapshot.pic");
		#endif
		snapshot(DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0));
		}


	}

}while(paused==1);


if (ffwd==0)
{


	Input_read( &file_input,frm,cy_vid_frame.size);

	#if DEBUG==1 
		TRACE("%d. Size:%ld Subtype:%ld",(c+1),cy_vid_frame.size,cy_vid_frame.subtype);
	#endif

	switch(cy_vid_frame.subtype)
	{
	case 0:
	memcpy(cyf,frm,4000);
	break;
	
	case 1:
	dec_enc_cv1(frm,cyf,cy_vid_frame.size);
	break;
	
	case 2:
	dec1_cv1(frm,cyf,cy_vid_frame.size);
	break;
	
	case 3:
	dec2_cv1(frm,cyf,cy_vid_frame.size);
	break;
	
	case 4:
	tablesize=frm[1]+(frm[0]<<8);

	#if DEBUG==1
		TRACE("TableSize: %ld",tablesize);
	#endif

	memcpy(table,(frm+2),tablesize);
	extract((frm+2+tablesize),cyf,code,table,tablesize,(cy_vid_frame.size-2-tablesize));
	break;

	default:
	#if DEBUG==1 
		TRACE("Unknown Frame Type");
	#endif
	break;

	}
	memcpy(scr,cyf,4000);

	/* Add subtitling */

	if (subs==1)
	{
		if (c==subhdr.frame)
		{
		memset(text,0,sizeof(text));
		Input_read(&sub_input,text,subhdr.length);

		#if DEBUG==1 
			TRACE("%d. [%d] >%s<",subhdr.frame,subhdr.length,text);
		#endif

		Input_read(&sub_input,&subhdr,6);
		}
		displaysub(text,ptr_main_module);
	}
	DisplayGraphics_show(ptr_main_module->m_gfx );
}
else
{
	FileInput_seek(&file_input,cy_vid_frame.size,SEEK_CUR);
}

}

}


FileInput_dtor( &sub_input, LEAVE_MEMORY );
FileInput_dtor( &file_input, LEAVE_MEMORY );


free(text);
free(subfile);
free(frm);
free(cyf);

free(code);
free(table);

}

