/*
Functions to handle the huffman decompress for
cvi + cvc  and cyf files. 
*/

#include <cybiko.h>

/* size 6 */
struct header
{
char id[4];
short files; /* Limit of 65000 files.... */
};

/* Size 18 */
struct files
{
short comp;
long jnk;   /* Space */
long csize; /* Compressed size */
long jnka;  /* Space */
int osize; /* Original size */
short namelen;
short tablelen;
};

//
// To save time and memory we are just going to load the table when required instead
// of generating it each time.
//
void gencode(char *node)
{
	struct FileInput file_input;
	
	FileInput_ctor(&file_input);
	
	if( !FileInput_open( &file_input,"table.huf"))
	{
	TRACE("Table file <table.huf> was not found on this Cybiko");
	}
	else
	{
	TRACE("Loading table");
	Input_read( &file_input,node,1024);
	}
	
	FileInput_dtor( &file_input, LEAVE_MEMORY);
}



// In code, Table of code, # of codes
int codematch(long in,long *code,short codes,int l)
{
int out=-1,i;

short skip[]={0,0,0,1,3,6,10,15,
21,28,36,45,55,66,78,91,
105,120,136,151,165,178,190,201,
211,220,228,235,241,246,250,253,
255,256};

//	for(i=0;i<codes;i++)

	for(i=skip[l];i<skip[l+1];i++)
	{
	if (code[i]==in){out=i;break;}
	}
return out;
}

long vb[]={
0x80000000,0x40000000,0x20000000,0x10000000,
0x08000000,0x04000000,0x02000000,0x01000000,
0x00800000,0x00400000,0x00200000,0x00100000,
0x00080000,0x00040000,0x00020000,0x00010000,
0x00008000,0x00004000,0x00002000,0x00001000,
0x00000800,0x00000400,0x00000200,0x00000100,
0x00000080,0x00000040,0x00000020,0x00000010,
0x00000008,0x00000004,0x00000002,0x00000001};

char va[]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};


// Extract from memory to memory

void extract(char *in,char *out,long *code, char *table,short tablesize,long size)
{
long outpos=0,inbyt=0,c=0;
int i,l=0,outcode;

while(c<size)
{
		for(i=0;i<8;i++)
		{
			if ((in[c] & va[i])==va[i] )
			{
				inbyt|=vb[l];
			}
			l++;

			if (l>1)
			{			
				outcode=codematch(inbyt,code,tablesize,l);
				if (outcode!=-1)
				{
				inbyt=0;
				l=0;
				out[outpos++]=table[outcode];
				}

				if (l>33)
				{
					TRACE("Code Length error!! code:%ld len:%d",inbyt,l);
					c=size;
					break;
				}
			}

		
		}
c++;
}		

}
