/*
Spectrum .scr viewer
*/

#include "cybiko.h"

int waitinput(struct module_t *);
void plot(char *scr,char *dis,long w,long h,long sx,long sy);
void gauge(struct module_t *,long,long);


void dec_spec(char *in,char *out,int s)
{
int x,y,of,ac=0,byt,pos,bit=0;

for(of=0;of<8;of++)
{
	for(y=s;y<(s+8);y++)
	{
		pos=(y*64*8)+(of*64);
	
		for(x=0;x<32;x++)
		{
		bit=in[ac++];
		byt=0;
	//
		if ((bit & 0x80)!=0x80){byt=192;}
		if ((bit & 64)!=64){byt+=48;}
		if ((bit & 32)!=32){byt+=12;}
		if ((bit & 16)!=16){byt+=3;}			
		out[pos]=byt;	
		pos++;
		
		byt=0;
		if ((bit & 8)!=8){byt=192;}
		if ((bit & 4)!=4){byt+=48;}
		if ((bit & 2)!=2){byt+=12;}
		if ((bit & 1)!=1){byt+=3;}			
		out[pos]=byt;
		pos++;
	//
		}
	}
}

}


void spectrum(char *myfile,struct module_t *ptr_main_module)
{
struct FileInput file_input;

int sx,sy,bx=256,by=192;

char *buf,*dis,*fil,abort;
buf=(char *)calloc(13000,sizeof(char)); // Screen buffer 256*192/4

dis=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

fil=dis; //Use screen as file buffer

//memset(buf,0,13000); 	// 256*192/4
memset(fil,0,2050);  	// 3 x 2048
memset(dis,0,4000);	// Clear display 

// Load file

FileInput_ctor(&file_input);

if( FileInput_open( &file_input,myfile  ))
{
Input_read( &file_input, fil,2048);
dec_spec(fil,buf,0);

Input_read( &file_input, fil,2048);
dec_spec(fil,buf,8);

Input_read( &file_input, fil,2048);
dec_spec(fil,buf,16);

//

abort=0;
sx=0;
sy=0;

// -------------

TRACE("Displaying.");

do
{
if (sx<0){sx=0;}
if (sy<0){sy=0;}
if ((sx<<2)+160>bx){sx=(bx>>2)-40;}
if ((sy+100)>by){sy=by-100;}
	
plot(buf,dis,bx,by,sx,sy);	
	
DisplayGraphics_show( ptr_main_module->m_gfx );
	

//--
switch(waitinput(ptr_main_module))
    {
	case KEY_ESC:
	abort=1;
	break;

	case KEY_UP:
	case KEY_Q:
	sy-=4;
	break; 

	case KEY_DOWN:
	case KEY_A:
	sy+=4;
	break;

	case KEY_LEFT:
	case KEY_O:
	sx-=1;
	break;

	case KEY_RIGHT:
	case KEY_P:
	sx+=1;
	break;	
}

}while(abort==0);
// -------------

}
else
{
TRACE("Could not open file..");
}

FileInput_dtor( &file_input, LEAVE_MEMORY);

free(buf);

}





